// BT62SettingSampDlg.cpp : t@C
// C_CAO
//
//Ver. 1.0.0 2023/05/09
//Eō쐬
//
// Җ
// RATOC Systems, Inc. 
//
// ec邱Ƃɏd_uĂ邽
//   G[ɂĂ͈ꕔȗĂ܂
//

#include "stdafx.h"
#include "BT62SettingSamp.h"
#include "ConfigDlg.h"
#include "BT62SettingSampDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


UINT ConnectedFunc(LPVOID lpParam);


// CBT62SettingSampDlg _CAO

CBT62SettingSampDlg::CBT62SettingSampDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBT62SettingSampDlg::IDD, pParent)
	, m_StrBaud(_T(""))
	, m_StrData(_T(""))
	, m_StrParity(_T(""))
	, m_StrStop(_T(""))
	, m_StrBtName(_T(""))
	, m_StrSend(_T(""))
	, m_StrReceive(_T(""))
	, m_DevNameIndex(0)
	, m_StrHIDPushTime(_T(""))
	, m_StrHIDCrLf(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_ComHandle = INVALID_HANDLE_VALUE;
	m_pConnectedThread = NULL;
	m_bConnectedThread = FALSE;
	memset(m_ReadBuf, 0x0,  sizeof(m_ReadBuf));
	memset((char *)&m_BtComInfo[0], 0x0, sizeof(BT_COM_INFO)*MAX_DEVNUM);
}

void CBT62SettingSampDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_CmbDevName);
	DDX_CBIndex(pDX, IDC_COMBO1, m_DevNameIndex);
	DDX_Text(pDX, IDC_EDIT1, m_StrBaud);
	DDX_Text(pDX, IDC_EDIT2, m_StrData);
	DDX_Text(pDX, IDC_EDIT3, m_StrParity);
	DDX_Text(pDX, IDC_EDIT4, m_StrStop);
	DDX_Text(pDX, IDC_EDIT6, m_StrBtName);
	DDX_Control(pDX, IDC_EDIT7, m_EdtSend);
	DDX_Text(pDX, IDC_EDIT7, m_StrSend);
	DDX_Control(pDX, IDC_EDIT8, m_EdtReceive);
	DDX_Text(pDX, IDC_EDIT8, m_StrReceive);
	DDX_Text(pDX, IDC_EDIT11, m_StrPINCode);
	DDX_Control(pDX, IDC_STATIC11, m_StcPINCode);
	DDX_Control(pDX, IDC_EDIT11, m_EdtPINCode);
	DDX_Text(pDX, IDC_EDIT12, m_StrAuth);
	DDX_Control(pDX, IDC_STATIC12, m_StcAuth);
	DDX_Control(pDX, IDC_EDIT12, m_EdtAuth);
	DDX_Text(pDX, IDC_EDIT13, m_StrFirmVer);
	DDX_Control(pDX, IDC_CLEAR, m_BtnClear);
	DDX_Control(pDX, IDC_CONFIG, m_BtnConfig);
	DDX_Control(pDX, IDC_SEND, m_BtnSend);
	DDX_Control(pDX, IDC_CONNECT, m_BtnConnect);
	DDX_Control(pDX, IDC_STATIC14, m_StcHIDPushTime);
	DDX_Control(pDX, IDC_STATIC15, m_StcHIDCrLf);
	DDX_Text(pDX, IDC_EDIT14, m_StrHIDPushTime);
	DDX_Text(pDX, IDC_EDIT15, m_StrHIDCrLf);
	DDX_Control(pDX, IDC_EDIT14, m_EdtHIDPushTime);
	DDX_Control(pDX, IDC_EDIT15, m_EdtHIDCrLf);
}

BEGIN_MESSAGE_MAP(CBT62SettingSampDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONFIG, &CBT62SettingSampDlg::OnBnClickedConfig)
	ON_BN_CLICKED(IDC_CONNECT, &CBT62SettingSampDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_SEND, &CBT62SettingSampDlg::OnBnClickedSend)
	ON_BN_CLICKED(IDC_CLEAR, &CBT62SettingSampDlg::OnBnClickedClear)
	ON_MESSAGE(WM_APP_UPDATE_RECEIVE, &CBT62SettingSampDlg::OnUpdateReceive)
END_MESSAGE_MAP()


// CBT62SettingSampDlg bZ[W nh

BOOL CBT62SettingSampDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	InquiryBtCom(m_BtComInfo);

	int	i;
	CString strBuf;

	for (i = 0; i < m_FindDevNum; i++)
    {
		m_CmbDevName.InsertString(i, (LPCTSTR)m_BtComInfo[i].dispName);
    }

	if(m_FindDevNum)
	{
		m_CmbDevName.SetCurSel(0);
	}

	// Ver 1.1.0.0 ǉ
	m_BtnConfig.EnableWindow(FALSE);
	m_BtnSend.EnableWindow(FALSE);
	m_BtnClear.EnableWindow(FALSE);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBT62SettingSampDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBT62SettingSampDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CBT62SettingSampDlg::OnCancel()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	CloseComPort();

	CDialog::OnCancel();
}

// ================================================================
//e
// ÓIȃXbh֐
// ÓIłȂ(static ̂Ȃ)oϐ֐QƂ邽߂
// ̊֐ReadDataWithOverLapped Xbh֐Ăяo
//
//	LPVOID lpParam			C_CAONX̃|C^
//߂l
//	0Ԃ
// ================================================================
UINT ConnectedFunc(LPVOID lpParam)
{
	CBT62SettingSampDlg* theDlg = static_cast<CBT62SettingSampDlg*>(lpParam);
    if (theDlg)
    {
        theDlg->ReadDataWithOverLapped();
    }
	return 0;
}

// ================================================================
//e
// C_CAONX̃Xbh֐
// 񓯊̃f[^M
//
//	Ȃ
//߂l
//	0Ԃ
// ================================================================
DWORD WINAPI CBT62SettingSampDlg::ReadDataWithOverLapped()
{
    OVERLAPPED ovlp;
	char szData[MAX_READLEN] = {0};
	DWORD nLen;
	DWORD nResult = 0;

	memset(&ovlp, 0, sizeof(OVERLAPPED));
    ovlp.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
    while(m_bConnectedThread)
    {
		if (m_ComHandle != INVALID_HANDLE_VALUE)
	    {
			if (!ReadFile(m_ComHandle, szData, sizeof(szData), &nResult, &ovlp)) 
			{
			    if (GetLastError() == ERROR_IO_PENDING) 
			    {
			        GetOverlappedResult(m_ComHandle, &ovlp, &nResult, TRUE);
			    }
				else
				{
				    TRACE("ReadDataWithOverLapped GetLastError() = %d\n", GetLastError());
				}
			}
			if (nResult)
			{
				nLen = strlen(m_ReadBuf);
				if((nLen + nResult) > sizeof(m_ReadBuf))
				{
					memset(m_ReadBuf, 0x0,  sizeof(m_ReadBuf));
					nLen = 0;
				}
				memcpy(m_ReadBuf+nLen, szData, nResult);
				m_StrReceive = (LPCTSTR)m_ReadBuf;
				// Xbh UpdateData()ĂׂȂ̂ŃbZ[W𑗐M
				// WM_APP_UPDATE_RECEIVEbZ[W𑗐M OnUpdateReceive()Ă΂
				this->PostMessage(WM_APP_UPDATE_RECEIVE, 0, 0);
			}
		}
        ResetEvent(ovlp.hEvent);
    }
    CloseHandle(ovlp.hEvent);
    TRACE("ReadDataWithOverLapped exit GetLastError() = %d\n", GetLastError());
    return 0;
}

// ================================================================
//e
// foCX̎擾
//
//	BT_COM_INFO *btComInfo	BT_COM_INFO\̂̃|C^
//	char *sourceBuf			foCX񂪊i[Ăobt@̃|C^
//							ex) "Bluetooth NoR̕WVA (COM5)"
//	const char *searchBuf	ڕ񂪊i[Ăobt@̃|C^
//  int index				ݒli[obt@̃|C^
//߂l
//	TRUE	
//	FALSE	s
// ================================================================
BOOL CBT62SettingSampDlg::ParseComNum(BT_COM_INFO *btComInfo, char *sourceBuf, const char *searchBuf, int index)
{
	char *pStart;
	char *pEnd;
	int	nLen;
	char numBuf[4]={0};

	if(!sourceBuf || !searchBuf)
	{
		return FALSE;
	}

	pStart = strstr(sourceBuf, searchBuf);
	if(!pStart)
	{
		return FALSE;
	}
	pStart = pStart + strlen(searchBuf);
	pEnd = strstr(pStart, ")");
	if(!pEnd)
	{
		return FALSE;
	}
	nLen = pEnd - pStart;
	if(nLen < 4)
	{
		memcpy(numBuf, pStart, nLen);
		btComInfo[index].comNumber = atoi(numBuf);
		sprintf_s(btComInfo[index].comName, sizeof(btComInfo[index].comName), "COM%s", numBuf);
		memcpy(btComInfo[index].dispName, sourceBuf, strlen(sourceBuf));
		TRACE("ParseComNum %s = %s\n", btComInfo[index].comName, btComInfo[index].dispName);
		return TRUE;
	}

	return FALSE;
}

// ================================================================
//e
// foCX̌o
//
//	Ȃ
//߂l
//	int index				oꂽfoCX
// ================================================================
int CBT62SettingSampDlg::InquiryBtCom(BT_COM_INFO *btComInfo)
{
	DWORD			dwIndex;
	TCHAR*			pszName;
	DWORD			dwSize;
	DWORD			dwRegType;
	BOOL			bRet;
	HDEVINFO		hDevInfo;
	SP_DEVINFO_DATA	sDevInfo;

	CString			cmpbuf;
	int				comIndex = 0;

	TCHAR*			pszHardName;

	hDevInfo = ::SetupDiGetClassDevs(NULL,0,0,DIGCF_PRESENT | DIGCF_ALLCLASSES);
	if(hDevInfo == INVALID_HANDLE_VALUE)
	{
		return false;
	}

	dwIndex = 0;
	::ZeroMemory(&sDevInfo,sizeof(SP_DEVINFO_DATA));
	sDevInfo.cbSize = sizeof(SP_DEVINFO_DATA);
	while(1)
	{
		bRet = ::SetupDiEnumDeviceInfo(hDevInfo,dwIndex++,&sDevInfo);
		if(bRet == FALSE)
		{
			break;
		}

		//th[l[̎擾
		//擾łȂƂ̂Ŏ擾łȂꍇcontinueȂ
		dwSize = 0;
		bRet = ::SetupDiGetDeviceRegistryProperty(hDevInfo,&sDevInfo,SPDRP_FRIENDLYNAME,&dwRegType,NULL,0,&dwSize);
		pszName = new TCHAR[dwSize];
		if(pszName)
		{
			bRet = ::SetupDiGetDeviceRegistryProperty(hDevInfo,&sDevInfo,SPDRP_FRIENDLYNAME,&dwRegType,(BYTE*)pszName,dwSize,&dwSize);

			if(bRet)
			{
				cmpbuf.LoadString(IDS_DEVNAME_USB);
				if(strstr(pszName, cmpbuf))
				{
					// COM̃foCXuUSB Serial Portv̏ꍇA
					;
				}
				else
				{
					cmpbuf.LoadString(IDS_DEVNAME_COM);
					if(strstr(pszName, cmpbuf))
					{
						// COM̃foCXuʐM|[gv܂ޏꍇA
						//uBluetoothv܂ނǂʂ
						cmpbuf.LoadString(IDS_DEVNAME_BLUETOOTH);
						if(strstr(pszName, cmpbuf))
						{
							dwSize = 0;
							bRet = ::SetupDiGetDeviceRegistryProperty(hDevInfo,&sDevInfo,SPDRP_HARDWAREID,&dwRegType,NULL,0,&dwSize);
							pszHardName = new TCHAR[dwSize];
							if(pszHardName)
							{
								bRet = ::SetupDiGetDeviceRegistryProperty(hDevInfo,&sDevInfo,SPDRP_HARDWAREID,&dwRegType,(BYTE*)pszHardName,dwSize,&dwSize);
								if( _strnicmp( pszHardName + strlen(pszHardName) - 4, "0000", 5 ) != 0 )
								{
									if(ParseComNum(btComInfo, pszName, "(COM", comIndex) == TRUE)
									{
										TRACE("pszName %s \n", pszName);
										comIndex++;
									}
								}
								delete	pszHardName;
							}
						}
						else
						{
							;
						}
					}
					else
					{
						dwSize = 0;
						bRet = ::SetupDiGetDeviceRegistryProperty(hDevInfo,&sDevInfo,SPDRP_HARDWAREID,&dwRegType,NULL,0,&dwSize);
						pszHardName = new TCHAR[dwSize];
						if(pszHardName)
						{
							bRet = ::SetupDiGetDeviceRegistryProperty(hDevInfo,&sDevInfo,SPDRP_HARDWAREID,&dwRegType,(BYTE*)pszHardName,dwSize,&dwSize);
							if( _strnicmp( pszHardName + strlen(pszHardName) - 4, "0000", 5 ) != 0 )
							{
								if(ParseComNum(btComInfo, pszName, "(COM", comIndex) == TRUE)
								{
									TRACE("pszName %s \n", pszName);
									comIndex++;
								}
							}
							delete	pszHardName;
						}
					}
				}
			}

			delete	pszName;
		}

		// oꂽfoCXMAX_DEVNUM ɒBꍇ͏𒆒f
		if(comIndex == MAX_DEVNUM)
		{
			break;
		}

	}

	::SetupDiDestroyDeviceInfoList(hDevInfo);

	m_FindDevNum = comIndex;

	return	comIndex;
}

// ================================================================
//e
// COM|[gnh̎擾
//
//  int portNum				COM|[gԍ
//  BOOL isAsyncMode		񓯊[hݒ
//߂l
//	HANDLE	COM|[gnh
//	INVALID_HANDLE_VALUE	s
// ================================================================
HANDLE CBT62SettingSampDlg::GetComPort(int portNum, BOOL isAsyncMode)
{
	HANDLE	hComPort;		// COM |[gpnh
	CString comPortName;
	COMMTIMEOUTS ctmo;
	DCB dcb;

	comPortName.Format( "\\\\.\\COM%d", portNum );

	SetWindowTextA( "BT62SettingSamp  connecting" );
	m_BtnConnect.EnableWindow(FALSE);

	// w|[gJ 
	if(isAsyncMode)
	{
		hComPort = CreateFile(
			(LPCTSTR)comPortName, 
			GENERIC_READ|GENERIC_WRITE,
			0, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
	}
	else
	{
		hComPort = CreateFile(
			(LPCTSTR)comPortName, 
			GENERIC_READ|GENERIC_WRITE,
			0, NULL, OPEN_EXISTING, 0, NULL);
	}

	if ( hComPort == INVALID_HANDLE_VALUE)
	{
		m_BtnConnect.EnableWindow(TRUE);
		return INVALID_HANDLE_VALUE;
	}

	// ^CAEg̐ݒBiKvɉĒ܂j
	memset(&ctmo,0,sizeof(ctmo));
	if(isAsyncMode)
	{
		ctmo.ReadIntervalTimeout = MAXDWORD;
	}
	else
	{
		// ʐMł͑҂ԂZƎMɎs
		ctmo.ReadIntervalTimeout = 100;
		ctmo.ReadTotalTimeoutConstant = 500;
		ctmo.WriteTotalTimeoutConstant = 500;
	}
	SetCommTimeouts(hComPort,&ctmo);

	// DCBݒiۂBluetoothʐMȂ̂ŕύXĂeȂ͗lj
	memset(&dcb,0,sizeof(dcb));
	dcb.DCBlength = sizeof(dcb);
	dcb.BaudRate = 115200;
	dcb.fBinary = 1;
	dcb.fDtrControl = DTR_CONTROL_ENABLE;
	dcb.fRtsControl = RTS_CONTROL_ENABLE;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;

	// |[g̃{[[gApeBݒ 
	SetCommState(hComPort, &dcb); 

	m_BtnConnect.EnableWindow(TRUE);
	UpdateTitle(TRUE);

	return hComPort;
}

// ================================================================
//e
// COM|[gnh̔j
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::CloseComPort(void)
{
	UpdateTitle(FALSE);
	m_bConnectedThread = FALSE;
	if (m_ComHandle != INVALID_HANDLE_VALUE)
	{
		// COM|[g̃N[Y
	    CloseHandle(m_ComHandle);
		m_ComHandle = INVALID_HANDLE_VALUE;
	}
}

// ================================================================
//e
// ݒf[^\
//
//	Ȃ
//߂l
//	TRUE  : 	
//	FALSE : s	
// ================================================================
BOOL CBT62SettingSampDlg::InitParameter( BOOL fMsgBox )
{
	BOOL 	isCmdMode = FALSE;
	CConfigDlg configDlg;
	char	szData[256]={0};
	int		nLen;
	char parseBuf[32]={0};
	BOOL	Status;
	BOOL	Ver477;

	UpdateData(TRUE);
	nLen = sizeof(szData);

	if(m_DevNameIndex<0)
	{
		m_tmpString.LoadString(IDS_STRING107);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		return FALSE;
	}

	m_StrBaud = "";
	m_StrData = "";
	m_StrParity = "";
	m_StrStop = "";
	m_StrAuth = "";
	m_StrFirmVer = "";
	m_StrPINCode = "";
	m_StrBtName = "";

	// Ver 1.3.0.0ǉ
	m_StrHIDPushTime = "";
	m_StrHIDCrLf = "";

	UpdateData(FALSE);

	// foCXdOFFɂOɂCOM|[gN[Y
	CloseComPort();
	//TRACE("OnBnClickedConfig m_comHandle = %d\n", m_ComHandle);

	// foCXdē_҂ _CAO <OK> ŏꂽ̃R[h
	m_ComHandle = GetComPort( m_BtComInfo[m_DevNameIndex].comNumber, FALSE );

	TRACE("InitParameter m_ComHandle = %d\n", m_ComHandle);
	if (m_ComHandle != INVALID_HANDLE_VALUE)
	{
		memset(szData, 0x0, nLen);
		// R}h[hɈڍs邽߁u***v(sȂ)𑗐M
		isCmdMode = SendAndCompareReceive("$$$", szData );
		if( _strnicmp( szData, "CMD\r\n", 5 ) != 0 )
			isCmdMode = FALSE;			
	}
	if(isCmdMode == FALSE)
	{
		m_tmpString.LoadString(IDS_STRING109);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		CloseComPort();
		return FALSE;
	}

	SetWindowTextA( "BT62SettingSamp" );
	if(isCmdMode == TRUE)
	{
		Ver477 = FALSE;
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V,\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "Ver 4.77", 8 ) == 0 )
				Ver477 = TRUE;				
			else
			{
			}

			// BT62łȂ΃G[Ƃ
			if( _strnicmp( szData, "BT62", 4 ) != 0 )
				Status = FALSE;

			theApp.m_StrVersion = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			m_tmpString.LoadString(IDS_STRING_VERSION);
			MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
			CloseComPort();
			return FALSE;
		}

		// Xgbvrbg
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GQ\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "0", 1 ) == 0 )
				m_StrStop = " 1";
			else if( _strnicmp( szData, "1", 1 ) == 0 )
				m_StrStop = " 2";
			else
				Status = FALSE;
			
			theApp.m_StrStop = m_StrStop;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return FALSE;
		}

		// {[[g
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GU\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "1200", 4 ) == 0 )
				m_StrBaud = " 1200";
			else if( _strnicmp( szData, "2400", 4 ) == 0 )
				m_StrBaud = " 2400";
			else if( _strnicmp( szData, "4800", 4 ) == 0 )
				m_StrBaud = " 4800";
			else if( _strnicmp( szData, "9600", 4 ) == 0 )
				m_StrBaud = " 9600";
			else if( _strnicmp( szData, "19200", 5 ) == 0 )
				m_StrBaud = " 19200";
			else if( _strnicmp( szData, "28800", 5 ) == 0 )
				m_StrBaud = " 28800";
			else if( _strnicmp( szData, "38400", 5 ) == 0 )
				m_StrBaud = " 38400";
			else if( _strnicmp( szData, "57600", 5 ) == 0 )
				m_StrBaud = " 57600";
			else if( _strnicmp( szData, "115200", 6 ) == 0 )
				m_StrBaud = " 115200";
			else if( _strnicmp( szData, "230400", 6 ) == 0 )
				m_StrBaud = " 230400";
			else if( _strnicmp( szData, "(0) raw", 7 ) == 0 )
			{
				m_StrBaud = " 115200";
				memset( szData, 0x00, sizeof(szData) );
				sprintf_s( szData, sizeof(szData), "115K" );
			}
			else
				Status = FALSE;

			theApp.m_StrBaud = m_StrBaud;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return FALSE;
		}

		// peB
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GL\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "None", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Even", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Odd", 3 ) == 0 )
				m_StrParity = "Odd ";

			else
				Status = FALSE;

			theApp.m_StrParity = m_StrParity;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return FALSE;
		}

		// f[^rbg
		if(	Ver477 )
		{
			memset(szData, 0x0, nLen);
			Status = SendAndCompareReceive("G7\r\n", szData );
			if( Status )
			{
				if( _strnicmp( szData, "0", 1 ) == 0 )
					m_StrData = " 8";
				else if( _strnicmp( szData, "1", 1 ) == 0 )
					m_StrData = " 7";
				else
					Status = FALSE;
				
				theApp.m_StrData = m_StrData;
			}
			if( !Status )
			{
				Status = SendAndCompareReceive("---\r\n", szData );

				CloseComPort();
				return FALSE;
			}
		}
		else
		{
			if( _strnicmp(theApp.m_StrVersion, "BT62", 4 ) == 0)
			{
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("G7\r\n", szData );
				if( Status )
				{
					if( _strnicmp( szData, "0", 1 ) == 0 )
						m_StrData = " 8";
					else if( _strnicmp( szData, "1", 1 ) == 0 )
						m_StrData = " 7";
					else
						Status = FALSE;
					
					theApp.m_StrData = m_StrData;
				}
				if( !Status )
				{
					Status = SendAndCompareReceive("---\r\n", szData );

					CloseComPort();
					return FALSE;
				}
			}
			else
			{
				m_StrData = " 8";
				theApp.m_StrData = m_StrData;
			}
		}


		if( _strnicmp( szData, "AOK\r\n", 5 ) != 0 )
		{
		}

		// Ver 1.1.0.0 ǉ
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V\r\n", szData );
		if( Status )
		{		
			m_StrFirmVer = szData;
			// "BT62 Ver."ȍ~̕\
			m_StrFirmVer = m_StrFirmVer.Mid( 9 );
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseComPort();
			return FALSE;
		}

		// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
		if( _strnicmp( m_StrFirmVer, "1.00", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( m_StrFirmVer, "1.01", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else
		{
			m_EdtAuth.ShowWindow( SW_SHOW );
			m_StcAuth.ShowWindow( SW_SHOW );

			// Ver 1.1.0.0 ǉ
			// Fؕ
			memset(szData, 0x0, nLen);
			Status = SendAndCompareReceive("GA\r\n", szData );
			if( Status )
			{
				if( _strnicmp( szData, "0", 1 ) == 0 )
				{
					m_StrAuth = "F Ȃ";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "1", 1 ) == 0 )
				{
					m_StrAuth = "SSPF";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "4", 1 ) == 0 )
				{
					m_StrAuth = "PINF";
					m_EdtPINCode.ShowWindow( SW_SHOW );
					m_StcPINCode.ShowWindow( SW_SHOW );
				}
				else
				{
					Status = FALSE;
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				
				theApp.m_StrAuth = m_StrAuth;

				// PINR[h
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GP\r\n", szData );
				if( Status )
				{
					m_StrPINCode = szData;
					m_StrPINCode.Replace( 0x0d, 0x00 );
					theApp.m_StrPINCode = m_StrPINCode;
				}
			}
			if( !Status )
			{
				m_EdtPINCode.ShowWindow( SW_HIDE );
				m_StcPINCode.ShowWindow( SW_HIDE );

				Status = SendAndCompareReceive("---\r\n", szData );

				CloseComPort();
				return FALSE;
			}
		
			// Ver 1.3.0.0 HID[h
			if( _strnicmp( m_StrFirmVer, "1.02", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );
			}
			else if( _strnicmp( m_StrFirmVer, "1.03", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );

				// 1.03.021.04i
				if( _strnicmp( m_StrFirmVer, "1.03.02", 7 ) == 0 )
				{
					m_StcHIDPushTime.ShowWindow( SW_SHOW );
					m_StcHIDCrLf.ShowWindow( SW_SHOW );
					m_EdtHIDPushTime.ShowWindow( SW_SHOW );
					m_EdtHIDCrLf.ShowWindow( SW_SHOW );
				}
			}
			// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
			else
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_EdtHIDPushTime.ShowWindow( SW_SHOW );
				m_EdtHIDCrLf.ShowWindow( SW_SHOW );
			}

		
		
		
			// Ver 1.3.0.0 HID
			if( m_StcHIDPushTime.IsWindowVisible()  )
			{
				// 搉̎
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GY\r\n", szData );
				if( Status )
				{
					m_StrHIDPushTime = szData;		
					m_StrHIDPushTime.Replace( 0x0d, 0x00 );
					theApp.m_StrHIDPushTime = m_StrHIDPushTime;
				}
				// s
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GO\r\n", szData );
				if( Status )
				{
					if( _strnicmp( szData, "0", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Enter";
					}
					else if( _strnicmp( szData, "1", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Ȃ";
					}
					else if( _strnicmp( szData, "2", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Enter";
					}
					else if( _strnicmp( szData, "3", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Ȃ";
					}

					theApp.m_StrHIDCrLf = m_StrHIDCrLf;
				}
			}	
		}


		// BluetoothName
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GN\r\n", szData );
		if( Status )
		{
			m_StrBtName = szData;		
			m_StrBtName.Replace( 0x0d, 0x00 );
			theApp.m_StrBtName = m_StrBtName;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return FALSE;
		}

		memset(szData, 0x0, nLen);
		// R}h[hÎ߂́u---vR}hs
		Status = SendAndCompareReceive("---\r\n", szData );
		if( _strnicmp( szData, "End\r\n", 5 ) != 0 )
			Status = FALSE;
		if( !Status )
		{
			CloseComPort();
			return FALSE;
		}
	}
	CloseComPort();
	UpdateData(FALSE);
	return TRUE;
}

// ================================================================
//e
// ^Cgo[XV
//
//  BOOL isConnected		ڑL
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::UpdateTitle(BOOL isConnected)
{
	CHAR	Title[128];

	if(isConnected)
	{
		sprintf_s( Title, sizeof(Title), "BT62SettingSamp  connected" );
	}
	else
	{
		sprintf_s( Title, sizeof(Title), "BT62SettingSamp" );
	}
	// _CAO^CgύX
	SetWindowTextA( Title );
}

// ================================================================
//e
//  ڑ{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedConnect()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	if(m_DevNameIndex<0)
	{
		m_tmpString.LoadString(IDS_STRING107);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		return;
	}
	TRACE("OnBnClickedConnect m_DevNameIndex = %d\n", m_DevNameIndex);
	UpdateData(FALSE);

	//CloseComPort();
	if( !InitParameter( TRUE ) )
		return;

	m_ComHandle = GetComPort( m_BtComInfo[m_DevNameIndex].comNumber, TRUE );
	if ( m_ComHandle == INVALID_HANDLE_VALUE)
	{
		SetWindowTextA( "BT62SettingSamp" );

	    TRACE("OnBnClickedConnect COMPort Open GetLastError() = %d\n", GetLastError());
		//m_tmpString.Format( "CreateFile GetLastError() = %d\n", GetLastError() );
		//MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		m_tmpString.LoadString(IDS_STRING108);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		return;
	}

	if (m_bConnectedThread == FALSE)
	{
		//  [JXbhN
		m_bConnectedThread = TRUE;
		m_pConnectedThread = AfxBeginThread(ConnectedFunc,(LPVOID)this);
		m_pConnectedThread->PostThreadMessage(WM_QUIT, 0, 0);
		m_pConnectedThread = NULL;
	}

	// Ver 1.1.0.0 ǉ
	m_BtnConnect.EnableWindow(TRUE);
	m_BtnConfig.EnableWindow(TRUE);
	m_BtnSend.EnableWindow(TRUE);
	m_BtnClear.EnableWindow(TRUE);

	UpdateData(FALSE);
}

// ================================================================
//e
// f[^̑MюMf[^Ɖf[^̔r
//
//	const char *txBuf		Mf[^i[Ăobt@̃|C^
//	const char *rxBuf		f[^i[Ăobt@̃|C^
//߂l
//	TRUE	
//	FALSE	s	
// ================================================================
BOOL CBT62SettingSampDlg::SendAndCompareReceive(const char *txBuf, const char *rxBuf )
{
	char	szData[256]={0};
	int		nLen;
	DWORD	nResult = 0;
	BOOL	bSuccess = FALSE;

	if(!txBuf || !rxBuf)
	{
		return FALSE;
	}

	//nLen = strlen("$$$"); ===> nLen = 3 ƂȂ R}h[hڍsɐ			
	//nLen = sizeof("$$$"); ===> nLen = 4 ƂȂ R}h[hڍsɎs
	// Mf[^擾邽߂ɂstrlen() gp
	nLen = strlen(txBuf);
	WriteFile(m_ComHandle, (char *)txBuf, nLen, &nResult, 0);

	if (nResult > 0) 
	{
		// DIP Switch擾R}h̏ꍇ
		if( _strnicmp( txBuf, "&\r\n", 3 ) == 0 )
		{
			Sleep(400);
		}

		//nLen = sizeof(szData); ===> nLen = 256 ƂȂ f[^Mɐ			
		//nLen = strlen(szData); ===> nLen = 0   ƂȂ f[^MɎs			
		// Mf[^擾邽߂ɂsizeof() gp
		nLen = sizeof(szData);
		memset(szData, 0x0, nLen);
		TRACE("SendAndCompareReceive WriteFile nResult = %d, recv nLen = %d\n", nResult, nLen);
		ReadFile(m_ComHandle, (char *)szData, sizeof(szData), &nResult, 0);

		if(nResult > 0)
		{
			if(rxBuf)
			{
				memcpy( (PVOID)rxBuf, szData, nResult ); 
				TRACE("SendAndCompareReceive ReadFile. szData(%d) = %s\n", nResult, szData);
				bSuccess = TRUE;
			}
		}
		else
		{
			TRACE("SendAndCompareReceive ReadFile nResult = %d, GetLastError() = %d\n", nResult, GetLastError());

			// gC
			ReadFile(m_ComHandle, (char *)szData, sizeof(szData), &nResult, 0);
			if(nResult > 0)
			{
				if(rxBuf)
				{
					memcpy( (PVOID)rxBuf, szData, nResult ); 
					TRACE("SendAndCompareReceive ReadFile. szData(%d) = %s\n", nResult, szData);
					bSuccess = TRUE;
				}
			}
		}
	}
	else
	{
		TRACE("SendAndCompareReceive WriteFile nResult = %d, GetLastError() = %d\n", nResult, GetLastError());
	}

	return bSuccess;
}

// ================================================================
//e
//  ݒ{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedConfig()
{
	CConfigDlg configDlg;
	INT_PTR dlgResponse;
	BOOL 	isCmdMode = FALSE;
	char	szData[256]={0};
	int		nLen;
	int		i;
	BOOL	fCancel;
	BOOL	Status;
	BOOL	Ver477;

	UpdateData(TRUE);
	nLen = sizeof(szData);

	if(m_DevNameIndex<0)
	{
		m_tmpString.LoadString(IDS_STRING107);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		return;
	}

	fCancel = FALSE;
	m_StrBaud = "";
	m_StrData = "";
	m_StrParity = "";
	m_StrStop = "";
	m_StrAuth = "";
	m_StrFirmVer = "";
	m_StrPINCode = "";
	m_StrBtName = "";
	m_StrHIDPushTime = "";
	m_StrHIDCrLf = "";
	UpdateData(FALSE);

	// foCXdOFFɂOɂCOM|[gN[Y
	CloseComPort();
	//TRACE("OnBnClickedConfig m_comHandle = %d\n", m_ComHandle);

	// foCXdē_҂ _CAO <OK> ŏꂽ̃R[h
	m_ComHandle = GetComPort( m_BtComInfo[m_DevNameIndex].comNumber, FALSE );

	TRACE("OnBnClickedConfig(send) m_ComHandle = %d\n", m_ComHandle);
	if (m_ComHandle != INVALID_HANDLE_VALUE)
	{
		memset(szData, 0x0, nLen);
		// R}h[hɈڍs邽߁u***v(sȂ)𑗐M
		isCmdMode = SendAndCompareReceive("$$$", szData );
		if( _strnicmp( szData, "CMD\r\n", 5 ) != 0 )
			isCmdMode = FALSE;
	}
	if(isCmdMode == FALSE)
	{
		m_tmpString.LoadString(IDS_STRING109);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		CloseComPort();
		return;
	}

	SetWindowTextA( "BT62SettingSamp" );
	if(isCmdMode == TRUE)
	{
		Ver477 = FALSE;
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V,\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "Ver 4.77", 8 ) == 0 )
				Ver477 = TRUE;
			else
			{
			}

			// BT62łȂ΃G[Ƃ
			if(  _strnicmp( szData, "BT62", 4 ) != 0 )
				Status = FALSE;

			theApp.m_StrVersion = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			m_tmpString.LoadString(IDS_STRING_VERSION);
			MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
			CloseComPort();
			return;
		}

		// Xgbvrbg
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GQ\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "0", 1 ) == 0 )
				m_StrStop = " 1";
			else if( _strnicmp( szData, "1", 1 ) == 0 )
				m_StrStop = " 2";
			else
				Status = FALSE;
			
			theApp.m_StrStop = m_StrStop;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseComPort();
			return;
		}

		// {[[g
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GU\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "1200", 4 ) == 0 )
				m_StrBaud = " 1200";
			else if( _strnicmp( szData, "2400", 4 ) == 0 )
				m_StrBaud = " 2400";
			else if( _strnicmp( szData, "4800", 4 ) == 0 )
				m_StrBaud = " 4800";
			else if( _strnicmp( szData, "9600", 4 ) == 0 )
				m_StrBaud = " 9600";
			else if( _strnicmp( szData, "19200", 5 ) == 0 )
				m_StrBaud = " 19200";
			else if( _strnicmp( szData, "28800", 5 ) == 0 )
				m_StrBaud = " 28800";
			else if( _strnicmp( szData, "38400", 5 ) == 0 )
				m_StrBaud = " 38400";
			else if( _strnicmp( szData, "57600", 5 ) == 0 )
				m_StrBaud = " 57600";
			else if( _strnicmp( szData, "115200", 6 ) == 0 )
				m_StrBaud = " 115200";
			else if( _strnicmp( szData, "230400", 6 ) == 0 )
				m_StrBaud = " 230400";
			else if( _strnicmp( szData, "(0) raw", 7 ) == 0 )
			{
				m_StrBaud = " 115200";
				memset( szData, 0x00, sizeof(szData) );
				sprintf_s( szData, sizeof(szData), "115K" );
			}
			else
				Status = FALSE;
			
			theApp.m_StrBaud = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseComPort();
			return;
		}

		// peB
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GL\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "None", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Even", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Odd", 3 ) == 0 )
				m_StrParity = "Odd ";

			else
				Status = FALSE;
			
			theApp.m_StrParity = m_StrParity;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseComPort();
			return;
		}

		// f[^rbg
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("G7\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "0", 1 ) == 0 )
				m_StrData = " 8";
			else if( _strnicmp( szData, "1", 1 ) == 0 )
				m_StrData = " 7";
			else
				Status = FALSE;
			
			theApp.m_StrData = m_StrData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseComPort();
			return;
		}

		// Ver 1.1.0.0 ǉ
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V\r\n", szData );
		if( Status )
		{		
			m_StrFirmVer = szData;
			// "BT62 Ver."ȍ~̕\
			m_StrFirmVer = m_StrFirmVer.Mid( 9 );
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseComPort();
			return;
		}

		// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
		if( _strnicmp( m_StrFirmVer, "1.00", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( m_StrFirmVer, "1.01", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else
		{
			m_EdtAuth.ShowWindow( SW_SHOW );
			m_StcAuth.ShowWindow( SW_SHOW );

			// Ver 1.1.0.0 ǉ
			// Fؕ
			memset(szData, 0x0, nLen);
			Status = SendAndCompareReceive("GA\r\n", szData );
			if( Status )
			{
				if( _strnicmp( szData, "0", 1 ) == 0 )
				{
					m_StrAuth = "F Ȃ";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "1", 1 ) == 0 )
				{
					m_StrAuth = "SSPF";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "4", 1 ) == 0 )
				{
					m_StrAuth = "PINF";
					m_EdtPINCode.ShowWindow( SW_SHOW );
					m_StcPINCode.ShowWindow( SW_SHOW );
				}
				else
				{
					Status = FALSE;
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				
				theApp.m_StrAuth = m_StrAuth;

				// PINR[h
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GP\r\n", szData );
				if( Status )
				{
					m_StrPINCode = szData;
					m_StrPINCode.Replace( 0x0d, 0x00 );
					theApp.m_StrPINCode = m_StrPINCode;
				}
			}
			if( !Status )
			{
				m_EdtPINCode.ShowWindow( SW_HIDE );
				m_StcPINCode.ShowWindow( SW_HIDE );

				Status = SendAndCompareReceive("---\r\n", szData );

				CloseComPort();
				return;
			}

			// Ver 1.3.0.0 HID[h
			if( _strnicmp( m_StrFirmVer, "1.02", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );
			}
			else if( _strnicmp( m_StrFirmVer, "1.03", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );

				// 1.03.021.04i
				if( _strnicmp( m_StrFirmVer, "1.03.02", 7 ) == 0 )
				{
					m_StcHIDPushTime.ShowWindow( SW_SHOW );
					m_StcHIDCrLf.ShowWindow( SW_SHOW );
					m_EdtHIDPushTime.ShowWindow( SW_SHOW );
					m_EdtHIDCrLf.ShowWindow( SW_SHOW );
				}
			}
			// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
			else
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_EdtHIDPushTime.ShowWindow( SW_SHOW );
				m_EdtHIDCrLf.ShowWindow( SW_SHOW );
			}

			// Ver 1.3.0.0 HID
			if( m_StcHIDPushTime.IsWindowVisible()  )
			{
				// m_StcHIDPushTime\ԂȂ
				memset(szData, 0x0, nLen);
				// 搉̎
				Status = SendAndCompareReceive("GY\r\n", szData );
				if( Status )
				{
					m_StrHIDPushTime = szData;		
					m_StrHIDPushTime.Replace( 0x0d, 0x00 );
					theApp.m_StrHIDPushTime = m_StrHIDPushTime;
				}
				// s
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GO\r\n", szData );
				if( Status )
				{
					if( _strnicmp( szData, "0", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Enter";
					}
					else if( _strnicmp( szData, "1", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Ȃ";
					}
					else if( _strnicmp( szData, "2", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Enter";
					}
					else if( _strnicmp( szData, "3", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Ȃ";
					}
					
					theApp.m_StrHIDCrLf = m_StrHIDCrLf;
				}
			}
		}


		// BluetoothName
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GN\r\n", szData );
		if( Status )
		{
			m_StrBtName = szData;		
			m_StrBtName.Replace( 0x0d, 0x00 );
			theApp.m_StrBtName = m_StrBtName;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return;
		}

		// BluetoothAdrs
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GB\r\n", szData );
		if( Status )
		{
			theApp.m_StrBtAddress = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return;
		}

		// DIP Switch
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("B\r\n", szData );
		if( Status )
		{
			// 9600Œ̏ꍇ
			if( strtoul( szData, NULL, 16 ) & 0x02 )
			{				
				MessageBox( TEXT("9600bpsŒ胂[hłB(DIP-SW[2]=ON)\r\nʐMx̕ύXsꍇ́Ãc[ŐݒύX\r\nDIP-SWύXĂB(DIP-SW[2]=OFF)"), TEXT("BT62SettingSamp"), MB_OK);
			}

		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseComPort();
			return;
		}

		// Ver 1.1.0.0 ǉ
		m_BtnConnect.EnableWindow(FALSE);
		m_BtnConfig.EnableWindow(FALSE);
		m_BtnSend.EnableWindow(FALSE);
		m_BtnClear.EnableWindow(FALSE);

		memcpy( configDlg.comName, m_BtComInfo[m_DevNameIndex].comName, sizeof(configDlg.comName) );
		dlgResponse = configDlg.DoModal();
		//TRACE("configDlg dlgResponse = %d\n",dlgResponse);
		if (dlgResponse == IDOK)
		{
			// ݒ_CAO <OK> ŏꂽ̃R[h
			for (i = 0; i < theApp.m_CmdItemCount; i++)
		    {
				// R}hs
				Status = SendAndCompareReceive(theApp.m_CmdItemString[i], szData );
				if( Status )
				{
					if( _strnicmp( szData, "AOK\r\n", 5 ) != 0 )
						Status = FALSE;
				}
				if( !Status )
					break;
				Sleep(40);
			}
			if( configDlg.fDefault == TRUE )
			{
				Sleep(500);
				Status = SendAndCompareReceive("SU,11\r\n", szData );
				Sleep(40);
				Status = SendAndCompareReceive("R,1\r\n", szData );
				Sleep(40);
			}

			// Ver 1.1.0.0 ԉŃN[YĂ̂MessageBoxOɈړB
			//             ɔđ̃N[YĂяoʒuC
			// foCXdOFFɂOɂ|[gؒf
			CloseComPort();

			// Ver 1.1.0.0 bZ[WC
			//MessageBox( TEXT("ݒύX܂B\r\nĎgpꍇ́A30b҂B\r\nftHgݒɕύXꍇ\r\nēxBlutoothyAOsKv܂B"), TEXT("BT62SettingSamp"), MB_OK | MB_ICONWARNING );
			MessageBox( TEXT("ݒύX܂B\r\n\r\nĎgpꍇ́A\r\nWindowsBluetoothݒ\r\nyBT62-xxxxzhyAOρhƂȂĂ\r\n{AvP[VIĂB\r\n\r\nuFؕvύXꍇ\r\nēxBluetoothyAOsKv܂B\r\n\r\niUser's ManualQƂBj\r\n"), TEXT("BT62SettingSamp"), MB_OK | MB_ICONWARNING );
		}
		else
		{
			fCancel = TRUE;
			// R}h[hÎ߂́u---vR}hs
			Status = SendAndCompareReceive("---\r\n", szData );

			Sleep(40);
			// foCXdOFFɂOɂ|[gؒf
			CloseComPort();
		}
	}
	else
	{
		// foCXdOFFɂOɂ|[gؒf
		CloseComPort();
	}

	// Ver 1.1.0.0 ǉ
	Sleep(2000);
	m_BtnConnect.EnableWindow(TRUE);
	m_BtnConfig.EnableWindow(FALSE);
	m_BtnSend.EnableWindow(FALSE);
	m_BtnClear.EnableWindow(FALSE);
	return;
}

// ================================================================
//e
//  M{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedSend()
{
	if (m_ComHandle != INVALID_HANDLE_VALUE)
    {
        OVERLAPPED ovlp;
        DWORD nResult = 0;

		memset(&ovlp, 0, sizeof(OVERLAPPED));
        ovlp.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

		UpdateData(TRUE);
        if (!WriteFile(m_ComHandle, (LPCTSTR)m_StrSend, m_StrSend.GetLength(), &nResult, &ovlp))
        {
            if (GetLastError() == ERROR_IO_PENDING) 
            {
                GetOverlappedResult(m_ComHandle, &ovlp, &nResult, TRUE);
            }
			else
			{
			    TRACE("OnBnClickedSend GetLastError() = %d\n", GetLastError());
			}
        }
        ResetEvent(ovlp.hEvent);
        CloseHandle(ovlp.hEvent);
    }
}

// ================================================================
//e
//  NA{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedClear()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	memset(m_ReadBuf, 0x0,  sizeof(m_ReadBuf));
	m_StrReceive = (LPCTSTR)m_ReadBuf;
	UpdateData(FALSE);
}

// ================================================================
//e
//  WM_APP_UPDATE_RECEIVE CxgbZ[W nh
//	XbhŃf[^MɃEChEXVȂ
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
LRESULT CBT62SettingSampDlg::OnUpdateReceive(WPARAM wParam, LPARAM lParam)
{
	UpdateData(FALSE);
	return 0;
}
