// BT62SettingSampDlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"

#include <Bthsdpdef.h> // Kv
#include <BluetoothAPIs.h>
#include <WinSock2.h>
#include <ws2bth.h>

#pragma comment(lib, "Bthprops")
#pragma comment(lib, "Ws2_32")


#define WM_SOCKET	WM_APP
#define MAX_READLEN	4096
#define MAX_DEVNUM	32


// CBT62SettingSampDlg _CAO
class CBT62SettingSampDlg : public CDialog
{
// RXgNV
public:
	CBT62SettingSampDlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_DIALOG1 };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g

// 
protected:
	HICON m_hIcon;
	SOCKET m_Socket;
	char	m_ReadBuf[MAX_READLEN];
	int		m_FindDevNum;
	BLUETOOTH_DEVICE_INFO m_BtInfo[MAX_DEVNUM];
	CString m_tmpString;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
public:
	CComboBox m_CmbDevName;
	int m_DevNameIndex;
	CString m_StrBaud;
	CString m_StrData;
	CString m_StrParity;
	CString m_StrStop;
	CString m_StrAuth;
	CEdit m_EdtAuth;
	CStatic m_StcAuth;

	CString m_StrFirmVer;

	CString m_StrPINCode;
	CEdit m_EdtPINCode;
	CStatic m_StcPINCode;

	CString m_StrBtName;
	CEdit m_EdtSend;
	CString m_StrSend;
	CEdit m_EdtReceive;
	CString m_StrReceive;
	afx_msg void OnBnClickedConfig();
	afx_msg void OnBnClickedConnect();
	afx_msg void OnBnClickedSend();
	afx_msg void OnBnClickedClear();
	afx_msg void OnBnClickedCancel();
	int InquiryBtDev(BLUETOOTH_DEVICE_INFO *btInfo);
	SOCKET GetBtSocket(BTH_ADDR btAddress);
	void CloseBtSocket(void);
	BOOL InitParameter( BOOL fMsgBox );
	void UpdateTitle(BOOL isConnected);
	BOOL SendAndCompareReceive(const char *txBuf, const char *rxBuf );
	CButton m_BtnClear;
	CButton m_BtnConfig;
	CButton m_BtnSend;
	CButton m_BtnConnect;
	CStatic m_StcHIDPushTime;
	CStatic m_StcHIDCrLf;
	CString m_StrHIDPushTime;
	CString m_StrHIDCrLf;
	CEdit m_EdtHIDPushTime;
	CEdit m_EdtHIDCrLf;
};
