// BT62SettingSampDlg.cpp : t@C
// C_CAO
//
//Ver. 1.0.0 2023/05/09
//Eō쐬
//
// Җ
// RATOC Systems, Inc. 
//
// ec邱Ƃɏd_uĂ邽
//   G[ɂĂ͈ꕔȗĂ܂
//

#include "stdafx.h"
#include "BT62SettingSamp.h"
#include "ConfigDlg.h"
#include "BT62SettingSampDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CBT62SettingSampDlg _CAO

CBT62SettingSampDlg::CBT62SettingSampDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBT62SettingSampDlg::IDD, pParent)
	, m_StrBaud(_T(""))
	, m_StrData(_T(""))
	, m_StrParity(_T(""))
	, m_StrStop(_T(""))
	, m_StrBtName(_T(""))
	, m_StrSend(_T(""))
	, m_StrReceive(_T(""))
	, m_DevNameIndex(0)
	, m_StrHIDPushTime(_T(""))
	, m_StrHIDCrLf(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_Socket = INVALID_SOCKET;
	memset(m_ReadBuf, 0x0,  sizeof(m_ReadBuf));
	memset((char *)&m_BtInfo[0], 0x0, sizeof(BLUETOOTH_DEVICE_INFO)*MAX_DEVNUM);
}

void CBT62SettingSampDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO1, m_CmbDevName);
	DDX_CBIndex(pDX, IDC_COMBO1, m_DevNameIndex);
	DDX_Text(pDX, IDC_EDIT1, m_StrBaud);
	DDX_Text(pDX, IDC_EDIT2, m_StrData);
	DDX_Text(pDX, IDC_EDIT3, m_StrParity);
	DDX_Text(pDX, IDC_EDIT4, m_StrStop);
	DDX_Text(pDX, IDC_EDIT6, m_StrBtName);
	DDX_Control(pDX, IDC_EDIT7, m_EdtSend);
	DDX_Text(pDX, IDC_EDIT7, m_StrSend);
	DDX_Control(pDX, IDC_EDIT8, m_EdtReceive);
	DDX_Text(pDX, IDC_EDIT8, m_StrReceive);
	DDX_Text(pDX, IDC_EDIT11, m_StrPINCode);
	DDX_Control(pDX, IDC_STATIC11, m_StcPINCode);
	DDX_Control(pDX, IDC_EDIT11, m_EdtPINCode);
	DDX_Text(pDX, IDC_EDIT12, m_StrAuth);
	DDX_Control(pDX, IDC_STATIC12, m_StcAuth);
	DDX_Control(pDX, IDC_EDIT12, m_EdtAuth);
	DDX_Text(pDX, IDC_EDIT13, m_StrFirmVer);
	DDX_Control(pDX, IDC_CLEAR, m_BtnClear);
	DDX_Control(pDX, IDC_CONFIG, m_BtnConfig);
	DDX_Control(pDX, IDC_SEND, m_BtnSend);
	DDX_Control(pDX, IDC_CONNECT, m_BtnConnect);
	DDX_Control(pDX, IDC_STATIC14, m_StcHIDPushTime);
	DDX_Control(pDX, IDC_STATIC15, m_StcHIDCrLf);
	DDX_Text(pDX, IDC_EDIT14, m_StrHIDPushTime);
	DDX_Text(pDX, IDC_EDIT15, m_StrHIDCrLf);
	DDX_Control(pDX, IDC_EDIT14, m_EdtHIDPushTime);
	DDX_Control(pDX, IDC_EDIT15, m_EdtHIDCrLf);
}

BEGIN_MESSAGE_MAP(CBT62SettingSampDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_CONFIG, &CBT62SettingSampDlg::OnBnClickedConfig)
	ON_BN_CLICKED(IDC_CONNECT, &CBT62SettingSampDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_SEND, &CBT62SettingSampDlg::OnBnClickedSend)
	ON_BN_CLICKED(IDC_CLEAR, &CBT62SettingSampDlg::OnBnClickedClear)
	ON_BN_CLICKED(IDCANCEL, &CBT62SettingSampDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// CBT62SettingSampDlg bZ[W nh

// ================================================================
//e
// _CAO
//
//	Ȃ
//߂l
// TRUE
// ================================================================
BOOL CBT62SettingSampDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B
	InquiryBtDev(m_BtInfo);

	int	i;
	CString strBuf;

	for (i = 0; i < m_FindDevNum; i++)
    {
		// WCHAR̃f[^CString^̕ϐɑ
		strBuf = (LPCWSTR) m_BtInfo[i].szName;
		if(strBuf.GetLength() == 0)
		{
			strBuf.Format("%02x:%02x:%02x:%02x:%02x:%02x", m_BtInfo[i].Address.rgBytes[5], m_BtInfo[i].Address.rgBytes[4], m_BtInfo[i].Address.rgBytes[3],
								m_BtInfo[i].Address.rgBytes[2], m_BtInfo[i].Address.rgBytes[1], m_BtInfo[i].Address.rgBytes[0]);
		}
		m_CmbDevName.InsertString(i, (LPCTSTR)strBuf);
    }

	if(m_FindDevNum)
	{
		m_CmbDevName.SetCurSel(0);
	}

	// Ver 1.1.0.0 ǉ
	m_BtnConfig.EnableWindow(FALSE);
	m_BtnSend.EnableWindow(FALSE);
	m_BtnClear.EnableWindow(FALSE);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CBT62SettingSampDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CBT62SettingSampDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// ================================================================
//e
// EBhE֑MꂽbZ[W܂B
//
//	UINT message	bZ[W̎ʎq
//  WPARAM wParam	bZ[W̍ŏ̃p[^
//  LPARAM lParam	bZ[W 2 Ԗڂ̃p[^
//߂l
//	bZ[W̌ʂԂ܂B
// ================================================================
LRESULT CBT62SettingSampDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB

	switch(message)
	{
		case WM_CREATE:
			TRACE("WindowProc message = %x\n", message);
			break;

		case WM_SOCKET:
			switch (WSAGETSELECTEVENT(lParam)) 
			{
				case FD_READ:
					if (m_Socket != INVALID_SOCKET) 
					{
						int  nLen;
						int  nResult;
						char szData[MAX_READLEN]={0};

						// nLen0ZbgĂƃf[^MłFD_READĂ΂ꑱ
						nLen = sizeof(szData);
						memset(szData, 0x0, nLen);
						nResult = recv(m_Socket, (char *)szData, nLen, 0);
			
						if(nResult > 0)
						{
							TRACE("FD_READ szData(%d) = %s\n", nResult, szData);
							nLen = strlen(m_ReadBuf);
							if((nLen + nResult) > sizeof(m_ReadBuf))
							{
								memset(m_ReadBuf, 0x0,  sizeof(m_ReadBuf));
							}
							memcpy(m_ReadBuf+nLen, szData, nResult);
							m_StrReceive = (LPCTSTR)m_ReadBuf;
							UpdateData(FALSE);
						}
						else
						{
							TRACE("FD_READ send nResult = %d, WSAGetLastError() = %d\n", nResult, WSAGetLastError());
						}
					}
					break;

				case FD_CLOSE:
					//MessageBox(TEXT("T[o[Ƃ̐ڑؒf܂B"), TEXT("OK"), MB_OK);
					TRACE("FD_CLOSE.. \n");
					CloseBtSocket();
					break;

			}
			return 0;

		case WM_DESTROY:
			CloseBtSocket();

			PostQuitMessage(0);
			return 0;

		default:
			break;
	}

	return CDialog::WindowProc(message, wParam, lParam);
}

// ================================================================
//e
// foCX̌oƃfoCX̎擾
//
//	BLUETOOTH_DEVICE_INFO *btInfo
//							BLUETOOTH_DEVICE_INFO\̂̃|C^
//߂l
//	int index				oꂽfoCX(MAX_DEVNUM𒴂Ȃ)
// ================================================================
int CBT62SettingSampDlg::InquiryBtDev(BLUETOOTH_DEVICE_INFO *btInfo)
{
	BLUETOOTH_DEVICE_SEARCH_PARAMS params = { 0 };
	params.fReturnAuthenticated = TRUE;
	params.fReturnRemembered = TRUE;
	params.fReturnUnknown = TRUE;
	params.fReturnConnected = TRUE;
	params.fIssueInquiry = TRUE;
	params.cTimeoutMultiplier = 5;
	params.dwSize = sizeof(BLUETOOTH_DEVICE_SEARCH_PARAMS);

	BLUETOOTH_DEVICE_INFO info = {0};
	info.dwSize = sizeof(BLUETOOTH_DEVICE_INFO);
	HBLUETOOTH_DEVICE_FIND find = BluetoothFindFirstDevice(&params, &info);
	int index = 0;

	if (find) 
	{
		do 
		{
			// Cho͂邽ߏw%Sɂ
			//TRACE("BtDevInquiry szName = %S\n", info.szName);
			memcpy(&btInfo[index], &info, sizeof(BLUETOOTH_DEVICE_INFO));
			index++;

			// oꂽfoCXMAX_DEVNUM ɒBꍇ͏𒆒f
			if(index == MAX_DEVNUM)
			{
				break;
			}

		} while(BluetoothFindNextDevice(find, &info));

	    BluetoothFindDeviceClose(find);
	}

	m_FindDevNum = index;

	return index;
}

// ================================================================
//e
// \Pbg̎擾
//
//	BTH_ADDR btAddress		BluetoothAhX
//߂l
//	SOCKET soc				\Pbg
//	INVALID_SOCKET			s
// ================================================================
SOCKET CBT62SettingSampDlg::GetBtSocket(BTH_ADDR btAddress)
{
	SOCKET soc, soc1;

	WSAData wsaData = { 0 };
    WSAStartup(MAKEWORD(2, 2), &wsaData);

	SetWindowTextA( "BT62SettingSamp  connecting" );
	m_BtnConnect.EnableWindow(FALSE);


    soc = socket(AF_BTH, SOCK_STREAM, BTHPROTO_RFCOMM);
    if (soc == INVALID_SOCKET) 
	{
		m_BtnConnect.EnableWindow(TRUE);
		return INVALID_SOCKET;
    }

    SOCKADDR_BTH sa = { 0 };
    sa.addressFamily = AF_BTH;
    sa.btAddr = (BTH_ADDR)btAddress;
    sa.serviceClassId = SerialPortServiceClass_UUID;
    sa.port = BT_PORT_ANY;

	soc1 = connect( soc, (sockaddr*)&sa, sizeof(sa) );
	if (soc1 == SOCKET_ERROR || soc1 != 0)
	{
		closesocket( soc );
		WSACleanup();

		m_BtnConnect.EnableWindow(TRUE);
		return INVALID_SOCKET;
	}

	m_BtnConnect.EnableWindow(TRUE);
	UpdateTitle(TRUE);
	return soc;
}

// ================================================================
//e
// \Pbg̔j
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::CloseBtSocket(void)
{
	UpdateTitle(FALSE);
	if (m_Socket != INVALID_SOCKET) 
	{
		shutdown(m_Socket, SD_BOTH);
		closesocket(m_Socket);
		WSACleanup();
		m_Socket = INVALID_SOCKET;
	}
}

// ================================================================
//e
//  ݒf[^\
//
//	Ȃ
//߂l
//	TRUE  : 	
//	FALSE : s	
// ================================================================
BOOL CBT62SettingSampDlg::InitParameter( BOOL fMsgBox )
{
	BOOL 	isCmdMode = FALSE;
	char	szData[256]={0};
	int		nLen;
	char parseBuf[32]={0};
	BOOL	Status;
	BOOL	Ver477;

	UpdateData(TRUE);
	nLen = sizeof(szData);

	if(m_DevNameIndex<0)
	{
		m_tmpString.LoadString(IDS_STRING107);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		return FALSE;
	}

	m_StrBaud = "";
	m_StrData = "";
	m_StrParity = "";
	m_StrStop = "";
	m_StrAuth = "";
	m_StrFirmVer = "";
	m_StrPINCode = "";
	m_StrBtName = "";

	// Ver 1.3.0.0ǉ
	m_StrHIDPushTime = "";
	m_StrHIDCrLf = "";

	UpdateData(FALSE);

	// foCXdOFFɂOɂ\Pbgؒf
	CloseBtSocket();
	//TRACE("OnBnClickedConfig m_Socket = %d\n", m_Socket);

	// foCXdē_҂ _CAO <OK> ŏꂽ̃R[h
	// WSAAsyncSelect ĂяoɃubLO[hŃR}h[hɂ
	m_Socket = GetBtSocket( m_BtInfo[m_DevNameIndex].Address.ullLong );
	TRACE("InitParameter m_Socket = %d\n", m_Socket);
	if (m_Socket != INVALID_SOCKET)
	{
		memset(szData, 0x0, nLen);
		// R}h[hɈڍs邽߁u***v(sȂ)𑗐M
		isCmdMode = SendAndCompareReceive("$$$", szData );
		if( _strnicmp( szData, "CMD\r\n", 5 ) != 0 )
			isCmdMode = FALSE;
	}
	if(isCmdMode == FALSE)
	{
		m_tmpString.LoadString(IDS_STRING109);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		CloseBtSocket();
		return FALSE;
	}

	SetWindowTextA( "BT62SettingSamp" );
	if(isCmdMode == TRUE)
	{
		Ver477 = FALSE;
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V,\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "Ver 4.77", 8 ) == 0 )
				Ver477 = TRUE;				
			else
			{
			}

			// BT62łȂ΃G[Ƃ
			if( _strnicmp( szData, "BT62", 4 ) != 0 )
				Status = FALSE;

			theApp.m_StrVersion = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			m_tmpString.LoadString(IDS_STRING_VERSION);
			MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
			CloseBtSocket();
			return FALSE;
		}

		// Xgbvrbg
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GQ\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "0", 1 ) == 0 )
				m_StrStop = " 1";
			else if( _strnicmp( szData, "1", 1 ) == 0 )
				m_StrStop = " 2";
			else
				Status = FALSE;
			
			theApp.m_StrStop = m_StrStop;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return FALSE;
		}

		// {[[g
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GU\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "1200", 4 ) == 0 )
				m_StrBaud = " 1200";
			else if( _strnicmp( szData, "2400", 4 ) == 0 )
				m_StrBaud = " 2400";
			else if( _strnicmp( szData, "4800", 4 ) == 0 )
				m_StrBaud = " 4800";
			else if( _strnicmp( szData, "9600", 4 ) == 0 )
				m_StrBaud = " 9600";
			else if( _strnicmp( szData, "19200", 5 ) == 0 )
				m_StrBaud = " 19200";
			else if( _strnicmp( szData, "28800", 5 ) == 0 )
				m_StrBaud = " 28800";
			else if( _strnicmp( szData, "38400", 5 ) == 0 )
				m_StrBaud = " 38400";
			else if( _strnicmp( szData, "57600", 5 ) == 0 )
				m_StrBaud = " 57600";
			else if( _strnicmp( szData, "115200", 6 ) == 0 )
				m_StrBaud = " 115200";
			else if( _strnicmp( szData, "230400", 6 ) == 0 )
				m_StrBaud = " 230400";
			else if( _strnicmp( szData, "(0) raw", 7 ) == 0 )
			{
				m_StrBaud = " 115200";
				memset( szData, 0x00, sizeof(szData) );
				sprintf_s( szData, sizeof(szData), "115K" );
			}
			else
				Status = FALSE;
			
			theApp.m_StrBaud = m_StrBaud;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return FALSE;
		}

		// peB
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GL\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "None", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Even", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Odd", 3 ) == 0 )
				m_StrParity = "Odd ";

			else
				Status = FALSE;
			
			theApp.m_StrParity = m_StrParity;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return FALSE;
		}

		// f[^rbg
		if(	Ver477 )
		{
			memset(szData, 0x0, nLen);
			Status = SendAndCompareReceive("G7\r\n", szData );
			if( Status )
			{
				if( _strnicmp( szData, "0", 1 ) == 0 )
					m_StrData = " 8";
				else if( _strnicmp( szData, "1", 1 ) == 0 )
					m_StrData = " 7";
				else
					Status = FALSE;
				
				theApp.m_StrData = m_StrData;
			}
			if( !Status )
			{
				Status = SendAndCompareReceive("---\r\n", szData );

				CloseBtSocket();
				return FALSE;
			}
		}
		else
		{
			if( _strnicmp(theApp.m_StrVersion, "BT62", 4 ) == 0)
			{
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("G7\r\n", szData );
				if( Status )
				{
					if( _strnicmp( szData, "0", 1 ) == 0 )
						m_StrData = " 8";
					else if( _strnicmp( szData, "1", 1 ) == 0 )
						m_StrData = " 7";
					else
						Status = FALSE;
					
					theApp.m_StrData = m_StrData;
				}
				if( !Status )
				{
					Status = SendAndCompareReceive("---\r\n", szData );

					CloseBtSocket();
					return FALSE;
				}
			}
			else
			{
				m_StrData = " 8";
				theApp.m_StrData = m_StrData;
			}
		}

		// Ver 1.1.0.0 ǉ
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V\r\n", szData );
		if( Status )
		{		
			m_StrFirmVer = szData;
			// "BT62 Ver."ȍ~̕\
			m_StrFirmVer = m_StrFirmVer.Mid( 9 );
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseBtSocket();
			return FALSE;
		}

		// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
		if( _strnicmp( m_StrFirmVer, "1.00", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( m_StrFirmVer, "1.01", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else
		{
			m_EdtAuth.ShowWindow( SW_SHOW );
			m_StcAuth.ShowWindow( SW_SHOW );

			// Ver 1.1.0.0 ǉ
			// Fؕ
			memset(szData, 0x0, nLen);
			Status = SendAndCompareReceive("GA\r\n", szData );
			if( Status )
			{
				if( _strnicmp( szData, "0", 1 ) == 0 )
				{
					m_StrAuth = "F Ȃ";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "1", 1 ) == 0 )
				{
					m_StrAuth = "SSPF";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "4", 1 ) == 0 )
				{
					m_StrAuth = "PINF";
					m_EdtPINCode.ShowWindow( SW_SHOW );
					m_StcPINCode.ShowWindow( SW_SHOW );
				}
				else
				{
					Status = FALSE;
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				
				theApp.m_StrAuth = m_StrAuth;

				// PINR[h
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GP\r\n", szData );
				if( Status )
				{
					m_StrPINCode = szData;
					m_StrPINCode.Replace( 0x0d, 0x00 );
					theApp.m_StrPINCode = m_StrPINCode;
				}
			}
			if( !Status )
			{
				m_EdtPINCode.ShowWindow( SW_HIDE );
				m_StcPINCode.ShowWindow( SW_HIDE );

				Status = SendAndCompareReceive("---\r\n", szData );

				CloseBtSocket();
				return FALSE;
			}

			// Ver 1.3.0.0 HID[h
			if( _strnicmp( m_StrFirmVer, "1.02", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );
			}
			else if( _strnicmp( m_StrFirmVer, "1.03", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );

				// 1.03.021.04i
				if( _strnicmp( m_StrFirmVer, "1.03.02", 7 ) == 0 )
				{
					m_StcHIDPushTime.ShowWindow( SW_SHOW );
					m_StcHIDCrLf.ShowWindow( SW_SHOW );
					m_EdtHIDPushTime.ShowWindow( SW_SHOW );
					m_EdtHIDCrLf.ShowWindow( SW_SHOW );
				}
			}
			// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
			else
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_EdtHIDPushTime.ShowWindow( SW_SHOW );
				m_EdtHIDCrLf.ShowWindow( SW_SHOW );
			}

			// Ver 1.3.0.0 HID
			if( m_StcHIDPushTime.IsWindowVisible()  )
			{
				// 搉̎
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GY\r\n", szData );
				if( Status )
				{
					m_StrHIDPushTime = szData;		
					m_StrHIDPushTime.Replace( 0x0d, 0x00 );
					theApp.m_StrHIDPushTime = m_StrHIDPushTime;
				}
				// s
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GO\r\n", szData );
				if( Status )
				{
					if( _strnicmp( szData, "0", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Enter";
					}
					else if( _strnicmp( szData, "1", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Ȃ";
					}
					else if( _strnicmp( szData, "2", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Enter";
					}
					else if( _strnicmp( szData, "3", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Ȃ";
					}
					
					theApp.m_StrHIDCrLf = m_StrHIDCrLf;
				}
			}
		}

		// BluetoothName
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GN\r\n", szData );
		if( Status )
		{
			m_StrBtName = szData;		
			m_StrBtName.Replace( 0x0d, 0x00 );
			theApp.m_StrBtName = m_StrBtName;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return FALSE;
		}

		memset(szData, 0x0, nLen);
		// R}h[hÎ߂́u---vR}hs
		Status = SendAndCompareReceive("---\r\n", szData );
		if( _strnicmp( szData, "End\r\n", 5 ) != 0 )
			Status = FALSE;
		if( !Status )
		{
			CloseBtSocket();
			return FALSE;
		}
	}
	CloseBtSocket();
	UpdateData(FALSE);
	return TRUE;
}

// ================================================================
//e
// ^Cgo[XV
//
//  BOOL isConnected		ڑL
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::UpdateTitle(BOOL isConnected)
{
	CHAR	Title[128];

	if(isConnected)
	{
		sprintf_s( Title, sizeof(Title), "BT62SettingSamp  connected" );
	}
	else
	{
		sprintf_s( Title, sizeof(Title), "BT62SettingSamp" );
	}
	// _CAO^CgύX
	SetWindowTextA( Title );
}

// ================================================================
//e
//  ڑ{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedConnect()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	UpdateData(TRUE);

	if(m_DevNameIndex<0)
	{
		m_tmpString.LoadString(IDS_STRING107);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK );
		return;
	}
	TRACE("OnBnClickedConnect m_DevNameIndex = %d\n", m_DevNameIndex);
	UpdateData(FALSE);

	//CloseBtSocket();
	if( !InitParameter( TRUE ) )
		return;

	m_Socket = GetBtSocket( m_BtInfo[m_DevNameIndex].Address.ullLong );

	if(m_Socket==INVALID_SOCKET)
	{
		SetWindowTextA( "BT62SettingSamp" );

		TRACE("OnBnClickedConnect Socket Open WSAGetLastError() = %d\n", WSAGetLastError());
		m_tmpString.LoadString(IDS_STRING108);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK );
		return;
	}

	// WSAAsyncSelectŎw̃\Pbg̎MؒfubLO[hɂB
	// ƂFD_READݒ肷邱ƂɂArecv֐͒ɐԂ悤ɂȂB
	// Mobt@Ƀf[^ƁAWindowProc֐FD_READbZ[Wʒm悤ɂȂB
	WSAAsyncSelect(m_Socket, theApp.m_pMainWnd->GetSafeHwnd(), WM_SOCKET, FD_READ | FD_CLOSE);

	// Ver 1.1.0.0 ǉ
	m_BtnConnect.EnableWindow(TRUE);
	m_BtnConfig.EnableWindow(TRUE);
	m_BtnSend.EnableWindow(TRUE);
	m_BtnClear.EnableWindow(TRUE);


	UpdateData(FALSE);
}

// ================================================================
//e
// f[^̑MюMf[^Ɖf[^̔r
//
//	const char *txBuf		Mf[^i[Ăobt@̃|C^
//	const char *rxBuf		f[^i[Ăobt@̃|C^
//߂l
//	TRUE	
//	FALSE	s	
// ================================================================
BOOL CBT62SettingSampDlg::SendAndCompareReceive(const char *txBuf, const char *rxBuf )
{
	char	szData[256]={0};
	int		nLen;
	int		nResult = 0;
	BOOL	bSuccess = FALSE;
	fd_set fds, readfds;
	struct timeval tv;

	if(txBuf)
	{
		//nLen = strlen("$$$"); ===> nLen = 3 ƂȂ R}h[hڍsɐ			
		//nLen = sizeof("$$$"); ===> nLen = 4 ƂȂ R}h[hڍsɎs
		// Mf[^擾邽߂ɂstrlen() gp
		nLen = strlen(txBuf);
		nResult = send(m_Socket, (char *)txBuf, nLen, 0);
	}

	if (nResult > 0) 
	{
		tv.tv_sec = 1;
		tv.tv_usec = 0;
		// fd_set̏܂
		FD_ZERO(&readfds);
		// selectő҂ǂݍ݃\PbgƂsock1o^܂
		FD_SET(m_Socket, &readfds);
		memcpy(&fds, &readfds, sizeof(fd_set));
		if( !select(0, &fds, NULL, NULL, &tv) )
		{
			return bSuccess;
		}
		// sock1ɓǂݍ݉\f[^Ȃꍇ
		if( !FD_ISSET(m_Socket, &fds) ) 
		{
			return bSuccess;
		}


		// DIP Switch擾R}h̏ꍇ
		if( _strnicmp( txBuf, "&\r\n", 3 ) == 0 )
		{
			Sleep(400);
		}

		//nLen = sizeof(szData); ===> nLen = 256 ƂȂ f[^Mɐ			
		//nLen = strlen(szData); ===> nLen = 0   ƂȂ f[^MɎs			
		// Mf[^擾邽߂ɂsizeof() gp
		nLen = sizeof(szData);
		memset(szData, 0x0, nLen);
		TRACE("SendAndCompareReceive send nResult = %d, recv nLen = %d\n", nResult, nLen);
		nResult = recv(m_Socket, (char *)szData, nLen, 0);

		if(nResult > 0)
		{
			if(rxBuf)
			{
				memcpy( (PVOID)rxBuf, szData, nResult ); 
				TRACE("SendAndCompareReceive recv. szData(%d) = %s\n", nResult, szData);
				bSuccess = TRUE;
			}
		}
		else
		{
			TRACE("SendAndCompareReceive recv nResult = %d, WSAGetLastError() = %d\n", nResult, WSAGetLastError());
		}
	}
	else
	{
		TRACE("SendAndCompareReceive send nResult = %d, WSAGetLastError() = %d\n", nResult, WSAGetLastError());
	}

	return bSuccess;
}

// ================================================================
//e
//  ݒ{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedConfig()
{
	CConfigDlg configDlg;
	INT_PTR dlgResponse;
	BOOL 	isCmdMode = FALSE;
	char	szData[256]={0};
	int		nLen;
	int		i;
	BOOL	fCancel;
	BOOL	Status;
	BOOL	Ver477;

	UpdateData(TRUE);
	nLen = sizeof(szData);

	if(m_DevNameIndex<0)
	{
		m_tmpString.LoadString(IDS_STRING107);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		return;
	}

	fCancel = FALSE;
	m_StrBaud = "";
	m_StrData = "";
	m_StrParity = "";
	m_StrStop = "";
	m_StrAuth = "";
	m_StrFirmVer = "";
	m_StrPINCode = "";
	m_StrBtName = "";
	m_StrHIDPushTime = "";
	m_StrHIDCrLf = "";
	UpdateData(FALSE);

	// foCXdOFFɂOɂ\Pbgؒf
	CloseBtSocket();
	//TRACE("OnBnClickedConfig m_Socket = %d\n", m_Socket);

	// foCXdē_҂ _CAO <OK> ŏꂽ̃R[h
	// WSAAsyncSelect ĂяoɃubLO[hŃR}h[hɂ
	m_Socket = GetBtSocket( m_BtInfo[m_DevNameIndex].Address.ullLong );
	TRACE("OnBnClickedConfig(send) m_Socket = %d\n", m_Socket);
	if (m_Socket != INVALID_SOCKET)
	{
		memset(szData, 0x0, nLen);
		// R}h[hɈڍs邽߁u***v(sȂ)𑗐M
		isCmdMode = SendAndCompareReceive("$$$", szData );
		if( _strnicmp( szData, "CMD\r\n", 5 ) != 0 )
			isCmdMode = FALSE;
	}
	if(isCmdMode == FALSE)
	{
		m_tmpString.LoadString(IDS_STRING109);
		MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
		CloseBtSocket();
		return;
	}

	SetWindowTextA( "BT62SettingSamp" );
	if(isCmdMode == TRUE)
	{
		Ver477 = FALSE;
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V,\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "Ver 4.77", 8 ) == 0 )
				Ver477 = TRUE;		
			else
			{
			}

			// BT62łȂ΃G[Ƃ
			if( _strnicmp( szData, "BT62", 4 ) != 0 )
				Status = FALSE;

			theApp.m_StrVersion = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			m_tmpString.LoadString(IDS_STRING_VERSION);
			MessageBox(m_tmpString, TEXT("BT62SettingSamp"), MB_OK);
			CloseBtSocket();
			return;
		}

		// Xgbvrbg
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GQ\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "0", 1 ) == 0 )
				m_StrStop = " 1";
			else if( _strnicmp( szData, "1", 1 ) == 0 )
				m_StrStop = " 2";
			else
				Status = FALSE;
			
			theApp.m_StrStop = m_StrStop;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseBtSocket();
			return;
		}

		// {[[g
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GU\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "1200", 4 ) == 0 )
				m_StrBaud = " 1200";
			else if( _strnicmp( szData, "2400", 4 ) == 0 )
				m_StrBaud = " 2400";
			else if( _strnicmp( szData, "4800", 4 ) == 0 )
				m_StrBaud = " 4800";
			else if( _strnicmp( szData, "9600", 4 ) == 0 )
				m_StrBaud = " 9600";
			else if( _strnicmp( szData, "19200", 5 ) == 0 )
				m_StrBaud = " 19200";
			else if( _strnicmp( szData, "28800", 5 ) == 0 )
				m_StrBaud = " 28800";
			else if( _strnicmp( szData, "38400", 5 ) == 0 )
				m_StrBaud = " 38400";
			else if( _strnicmp( szData, "57600", 5 ) == 0 )
				m_StrBaud = " 57600";
			else if( _strnicmp( szData, "115200", 6 ) == 0 )
				m_StrBaud = " 115200";
			else if( _strnicmp( szData, "230400", 6 ) == 0 )
				m_StrBaud = " 230400";
			else if( _strnicmp( szData, "(0) raw", 7 ) == 0 )
			{
				m_StrBaud = " 115200";
				memset( szData, 0x00, sizeof(szData) );
				sprintf_s( szData, sizeof(szData), "115K" );
			}
			else
				Status = FALSE;
			
			theApp.m_StrBaud = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseBtSocket();
			return;
		}

		// peB
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GL\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "None", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Even", 4 ) == 0 )
				m_StrParity = szData;
			else if( _strnicmp( szData, "Odd", 3 ) == 0 )
				m_StrParity = "Odd ";

			else
				Status = FALSE;
			
			theApp.m_StrParity = m_StrParity;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseBtSocket();
			return;
		}

		// f[^rbg
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("G7\r\n", szData );
		if( Status )
		{
			if( _strnicmp( szData, "0", 1 ) == 0 )
				m_StrData = " 8";
			else if( _strnicmp( szData, "1", 1 ) == 0 )
				m_StrData = " 7";
			else
				Status = FALSE;
			
			theApp.m_StrData = m_StrData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseBtSocket();
			return;
		}


		// Ver 1.1.0.0 ǉ
		// o[W
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("V\r\n", szData );
		if( Status )
		{		
			m_StrFirmVer = szData;
			// "BT62 Ver."ȍ~̕\
			m_StrFirmVer = m_StrFirmVer.Mid( 9 );
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );
			CloseBtSocket();
			return;
		}

		// Ver 1.2.0.0 "BT62 Ver."ȍ~̊mFĔFؕ
		if( _strnicmp( m_StrFirmVer, "1.00", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else if( _strnicmp( m_StrFirmVer, "1.01", 4 ) == 0 )
		{
			m_EdtAuth.ShowWindow( SW_HIDE );
			m_StcAuth.ShowWindow( SW_HIDE );

			// Ver 1.3.0.0 HID[h
			m_StcHIDPushTime.ShowWindow( SW_HIDE );
			m_StcHIDCrLf.ShowWindow( SW_HIDE );
			m_EdtHIDPushTime.ShowWindow( SW_HIDE );
			m_EdtHIDCrLf.ShowWindow( SW_HIDE );
		}
		else
		{
			m_EdtAuth.ShowWindow( SW_SHOW );
			m_StcAuth.ShowWindow( SW_SHOW );

			// Ver 1.1.0.0 ǉ
			// Fؕ
			memset(szData, 0x0, nLen);
			Status = SendAndCompareReceive("GA\r\n", szData );
			if( Status )
			{
				if( _strnicmp( szData, "0", 1 ) == 0 )
				{
					m_StrAuth = "F Ȃ";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "1", 1 ) == 0 )
				{
					m_StrAuth = "SSPF";
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				else if( _strnicmp( szData, "4", 1 ) == 0 )
				{
					m_StrAuth = "PINF";
					m_EdtPINCode.ShowWindow( SW_SHOW );
					m_StcPINCode.ShowWindow( SW_SHOW );
				}
				else
				{
					Status = FALSE;
					m_EdtPINCode.ShowWindow( SW_HIDE );
					m_StcPINCode.ShowWindow( SW_HIDE );
				}
				
				theApp.m_StrAuth = m_StrAuth;

				// PINR[h
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GP\r\n", szData );
				if( Status )
				{
					m_StrPINCode = szData;
					m_StrPINCode.Replace( 0x0d, 0x00 );
					theApp.m_StrPINCode = m_StrPINCode;
				}
			}
			if( !Status )
			{
				m_EdtPINCode.ShowWindow( SW_HIDE );
				m_StcPINCode.ShowWindow( SW_HIDE );

				Status = SendAndCompareReceive("---\r\n", szData );

				CloseBtSocket();
				return;
			}

			// Ver 1.3.0.0 HID[h
			if( _strnicmp( m_StrFirmVer, "1.02", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );
			}
			else if( _strnicmp( m_StrFirmVer, "1.03", 4 ) == 0 )
			{
				m_StcHIDPushTime.ShowWindow( SW_HIDE );
				m_StcHIDCrLf.ShowWindow( SW_HIDE );
				m_EdtHIDPushTime.ShowWindow( SW_HIDE );
				m_EdtHIDCrLf.ShowWindow( SW_HIDE );

				// 1.03.021.04i
				if( _strnicmp( m_StrFirmVer, "1.03.02", 7 ) == 0 )
				{
					m_StcHIDPushTime.ShowWindow( SW_SHOW );
					m_StcHIDCrLf.ShowWindow( SW_SHOW );
					m_EdtHIDPushTime.ShowWindow( SW_SHOW );
					m_EdtHIDCrLf.ShowWindow( SW_SHOW );
				}
			}
			// Ver 1.3.0.0 HID (2024/05/14) t@[o[W"1.04"ȍ~
			else
			{
				m_StcHIDPushTime.ShowWindow( SW_SHOW );
				m_StcHIDCrLf.ShowWindow( SW_SHOW );
				m_EdtHIDPushTime.ShowWindow( SW_SHOW );
				m_EdtHIDCrLf.ShowWindow( SW_SHOW );
			}

			// Ver 1.3.0.0 HID
			if( m_StcHIDPushTime.IsWindowVisible()  )
			{
				// m_StcHIDPushTime\ԂȂ
				memset(szData, 0x0, nLen);
				// 搉̎
				Status = SendAndCompareReceive("GY\r\n", szData );
				if( Status )
				{
					m_StrHIDPushTime = szData;		
					m_StrHIDPushTime.Replace( 0x0d, 0x00 );
					theApp.m_StrHIDPushTime = m_StrHIDPushTime;
				}
				// s
				memset(szData, 0x0, nLen);
				Status = SendAndCompareReceive("GO\r\n", szData );
				if( Status )
				{
					if( _strnicmp( szData, "0", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Enter";
					}
					else if( _strnicmp( szData, "1", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Enter / LF:Ȃ";
					}
					else if( _strnicmp( szData, "2", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Enter";
					}
					else if( _strnicmp( szData, "3", 1 ) == 0 )
					{
						m_StrHIDCrLf = "CR:Ȃ / LF:Ȃ";
					}
					
					theApp.m_StrHIDCrLf = m_StrHIDCrLf;
				}
			}
		}

		// BluetoothName
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GN\r\n", szData );
		if( Status )
		{
			m_StrBtName = szData;		
			m_StrBtName.Replace( 0x0d, 0x00 );
			theApp.m_StrBtName = m_StrBtName;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return;
		}

		// BluetoothAdrs
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("GB\r\n", szData );
		if( Status )
		{
			theApp.m_StrBtAddress = szData;
		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return;
		}

		// DIP Switch
		memset(szData, 0x0, nLen);
		Status = SendAndCompareReceive("B\r\n", szData );
		if( Status )
		{
			// 9600Œ̏ꍇ
			if( strtoul( szData, NULL, 16 ) & 0x02 )
			{				
				MessageBox( TEXT("9600bpsŒ胂[hłB(DIP-SW[2]=ON)\r\nʐMx̕ύXsꍇ́Ãc[ŐݒύX\r\nDIP-SWύXĂB(DIP-SW[2]=OFF)"), TEXT("BT62SettingSamp"), MB_OK);
			}

		}
		if( !Status )
		{
			Status = SendAndCompareReceive("---\r\n", szData );

			CloseBtSocket();
			return;
		}

		// Ver 1.1.0.0 ǉ
		m_BtnConnect.EnableWindow(FALSE);
		m_BtnConfig.EnableWindow(FALSE);
		m_BtnSend.EnableWindow(FALSE);
		m_BtnClear.EnableWindow(FALSE);

		dlgResponse = configDlg.DoModal();
		//TRACE("configDlg dlgResponse = %d\n",dlgResponse);
		if (dlgResponse == IDOK)	
		{
			// ݒ_CAO <OK> ŏꂽ̃R[h
			for (i = 0; i < theApp.m_CmdItemCount; i++)
		    {
				// R}hs
				Status = SendAndCompareReceive(theApp.m_CmdItemString[i], szData );
				if( Status )
				{
					if( _strnicmp( szData, "AOK\r\n", 5 ) != 0 )
						Status = FALSE;
				}

				if( !Status )
					break;
			}

			if( configDlg.fDefault == TRUE )
			{
				Sleep(500);
				Status = SendAndCompareReceive("SU,11\r\n", szData );
				Sleep(40);
				Status = SendAndCompareReceive("R,1\r\n", szData );
				Sleep(40);
			}

			// Ver 1.1.0.0 ԉŃN[YĂ̂MessageBoxOɈړB
			//             ɔđ̃N[YĂяoʒuC
			// foCXdOFFɂOɂ\Pbgؒf
			CloseBtSocket();

			// Ver 1.1.0.0 bZ[WC
			//MessageBox( TEXT("ݒύX܂B\r\nĎgpꍇ́A30b҂B\r\nftHgݒɕύXꍇ\r\nēxBlutoothyAOsKv܂B"), TEXT("BT62SettingSamp"), MB_OK | MB_ICONWARNING );
			MessageBox( TEXT("ݒύX܂B\r\n\r\nĎgpꍇ́A\r\nWindowsBluetoothݒ\r\nyBT62-xxxxzhyAOρhƂȂĂ\r\n{AvP[VIĂB\r\n\r\nuFؕvύXꍇ\r\nēxBluetoothyAOsKv܂B\r\n\r\niUser's ManualQƂBj\r\n"), TEXT("BT62SettingSamp"), MB_OK | MB_ICONWARNING );
		}
		else
		{
			fCancel = TRUE;
			Status = SendAndCompareReceive("---\r\n", szData );
			Sleep(40);

			// foCXdOFFɂOɂ\Pbgؒf
			CloseBtSocket();
		}
	}
	else
	{
		// foCXdOFFɂOɂ\Pbgؒf
		CloseBtSocket();
	}

	// Ver 1.1.0.0 ǉ
	Sleep(2000);
	m_BtnConnect.EnableWindow(TRUE);
	m_BtnConfig.EnableWindow(FALSE);
	m_BtnSend.EnableWindow(FALSE);
	m_BtnClear.EnableWindow(FALSE);

	return;
}

// ================================================================
//e
//  M{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedSend()
{
	if (m_Socket != INVALID_SOCKET)
	{
		UpdateData(TRUE);
		send(m_Socket, (LPCTSTR)m_StrSend, m_StrSend.GetLength(), 0);
	}
}

// ================================================================
//e
//  NA{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedClear()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	memset(m_ReadBuf, 0x0,  sizeof(m_ReadBuf));
	m_StrReceive = (LPCTSTR)m_ReadBuf;
	UpdateData(FALSE);
}

// ================================================================
//e
//  LZ{^NbN̏
//
//	Ȃ
//߂l
//	Ȃ	
// ================================================================
void CBT62SettingSampDlg::OnBnClickedCancel()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CloseBtSocket();
	OnCancel();
}

